organize / cleanup
[distro-setup] / mount-latest-subvol
1 #!/bin/bash
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 # usage: mount-latest-subvol
17
18 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
19
20 errcatch() {
21 set -E; shopt -s extdebug
22 _err-trap() {
23 err=$?
24 exec >&2
25 set +x
26 echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}:in \`$BASH_COMMAND' returned $err"
27 bash-trace 2
28 echo "$0: exiting with code $err"
29 exit $err
30 }
31 trap _err-trap ERR
32 set -o pipefail
33 }
34 bash-trace() {
35 local -i argc_index=0 frame i start=${1:-1} max_indent=8 indent
36 local source
37 local extdebug=false
38 if [[ $(shopt -p extdebug) == *-s* ]]; then
39 extdebug=true
40 fi
41
42 for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
43 argc=${BASH_ARGC[frame]}
44 argc_index+=$argc
45 ((frame < start)) && continue
46 if (( ${#BASH_SOURCE[@]} > 1 )); then
47 source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
48 fi
49 indent=$((frame-start+1))
50 indent=$((indent < max_indent ? indent : max_indent))
51 printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
52 if $extdebug; then
53 for ((i=argc_index-1; i >= argc_index-argc; i--)); do
54 printf " %s" "${BASH_ARGV[i]}"
55 done
56 fi
57 echo \'
58 done
59 }
60 errcatch
61
62 tu() {
63 while read -r line; do
64 file="$1"
65 grep -xFq "$line" "$file" || tee -a "$file"<<<"$line"
66 done
67 }
68 e() { printf "%s\n" "$*"; "$@"; }
69 mnt() {
70 dir=$1
71 if ! mountpoint $dir &>/dev/null; then
72 mkdir -p $dir
73 e mount $dir
74 fi
75 }
76 fstab() {
77 while read -r start mpoint end; do
78 l="$start $mpoint $end"
79 # kill off any lines that duplicate the mount point.
80 sed --follow-symlinks -ri "\%$l%b;\%^\s*\S+\s+$mpoint\s%d" /etc/fstab
81 tu /etc/fstab <<<"$l"
82 done
83 }
84 kill-dir() {
85 found_pids=false
86 sig=${1:-TERM}
87 if pids=$(timeout 4 lsof -t $dir); then
88 found_pids=true
89 timeout 4 lsof -w $dir
90 kill -$sig $pids
91 fi
92 # fuser will find open sockets that lsof won't, for example from gpg-agent.
93 # note: -v shows kernel processes, which then doesn't return true when we want
94 if timeout 4 fuser -m $dir &>/dev/null; then
95 found_pids=true
96 fuser -$sig -mvk $dir
97 fi
98 if $found_pids; then
99 sleep .5
100 return 0
101 fi
102 return 1
103 }
104
105 force=false
106 if [[ $1 == -f ]]; then
107 force=true
108 fi
109
110 ret=0
111
112 ##### begin setup fstab for subvols we care about ######
113 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
114 fstab <<EOF
115 $first_root_crypt /a btrfs noatime,subvol=a 0 0
116 EOF
117
118 shopt -s nullglob
119
120 # ssh and probably some other things care about parent directory
121 # ownership, and ssh doesn\'t allow any group writable parent
122 # directories, so we are forced to use a directory structure similar
123 # to home directories
124 f=(/mnt/root/btrbk/q.*)
125 if [[ -e $f ]]; then
126 fstab <<EOF
127 $first_root_crypt /q btrfs noatime,subvol=q,gid=1000 0 0
128 /q/p /p none bind 0 0
129 EOF
130 fi
131
132 f=(/mnt/root/btrbk/o.*)
133 if [[ -e $f ]]; then
134 fstab <<EOF
135 $first_root_crypt /o btrfs noatime,subvol=o 0 0
136 /o/m /m none bind 0 0
137 EOF
138 fi
139
140 if [[ $HOSTNAME == frodo ]]; then
141 fstab <<EOF
142 $first_root_crypt /i btrfs noatime,subvol=i 0 0
143 EOF
144 fi
145 ##### end setup fstab for subvols we care about ######
146
147 for vol in q a o i; do
148 d=/$vol
149 if ! awk '{print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
150 continue
151 fi
152
153
154 ##### begin building up list of bind mounts ######
155 binds=() # list of bind mounts
156 roots=($d) # list of bind mounts, plus the original mount
157 while true; do
158 new_roots=()
159 for r in ${roots[@]}; do
160 # eg. when r=/q/p, for lines like
161 # /q/p /p none bind 0 0
162 # output /p
163 new_roots+=($(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+bind\s.*#\1#p" /etc/fstab))
164 done
165 (( ${#new_roots} )) || break
166 binds+=(${new_roots[@]})
167 roots=( ${new_roots[@]} )
168 done
169 ##### end building up list of bind mounts ######
170
171
172 # if latest is already mounted, make sure binds are mounted and move on
173 if e check-subvol-stale $d; then
174 mnt $d
175 for b in ${binds[@]}; do
176 mnt $b
177 done
178 continue
179 fi
180
181 fresh_snap=$(</nocow/btrfs-stale/$vol)
182 if [[ ! $fresh_snap ]]; then
183 echo "$0: error. empty fresh_snap var"
184 ret=1
185 continue
186 fi
187
188 umount_ret=true
189 unmounted=()
190 for dir in $(echo $d ${binds[*]}\ |tac -s\ ); do
191 if mountpoint $dir; then
192 if e umount -R $dir; then
193 unmounted+=($dir)
194 else
195 kill-dir || kill-dir INT || kill-dir HUP || ! $force || kill-dir KILL ||:
196
197 if e umount -R $dir; then
198 unmounted+=($dir)
199 else
200 echo "$0: failed to umount $dir"
201 umount_ret=false
202 ret=1
203 continue
204 fi
205 fi
206 fi
207 done
208
209 if ! $umount_ret; then
210 for dir in ${unmounted[@]}; do
211 mnt $dir
212 done
213 continue
214 fi
215
216 # todo: decipher /mnt/root, like we do in check-subvol-stale
217 cd /mnt/root
218 if [[ -e $vol ]]; then
219 e mv $vol $vol.leaf.$(date +%Y%m%dT%H%M%S%z)
220 fi
221 # Note, we make a few assumptions in this script, like
222 # $d was not a different subvol id than $vol, and
223 # things otherwise didn't get mounted very strangely.
224 e btrfs sub snapshot $fresh_snap $vol
225 for dir in $d ${binds[@]}; do
226 e mnt $dir
227 done
228 stale_dir=/nocow/btrfs-stale
229 rm -f $stale_dir/$d
230 done
231
232 ### disabled
233 if [[ $HOSTNAME == treetowlxxxxxxxxx ]]; then
234 # partitioned it with fai partitioner outside of fai,
235 # because it\'s worth it to have 1% space reserved for boot and
236 # swap partitions in case I ever want to boot off those drives.
237 # as root:
238 # . /a/bin/fai/fai-wrapper
239 # eval-fai-classfile /a/bin/fai/fai/config/class/51-multi-boot
240 # fai-setclass ROTATIONAL
241 # export LUKS_DIR=/q/root/luks/
242 # # because the partition nums existed already
243 # fai-setclass REPARTITION
244 # /a/bin/fai/fai/config/hooks/partition.DEFAULT
245
246 devs=(
247 ata-TOSHIBA_MD04ACA500_84REK6NTFS9A-part1
248 ata-TOSHIBA_MD04ACA500_84R2K773FS9A-part1
249 ata-TOSHIBA_MD04ACA500_8471K430FS9A-part1
250 ata-TOSHIBA_MD04ACA500_8481K493FS9A-part1
251 )
252 first=true
253 for dev in ${devs[@]}; do
254 if $first; then
255 first=false
256 tu /etc/fstab <<EOF
257 /dev/mapper/crypt_dev_$dev /i btrfs noatime,subvol=i,noauto 0 0
258 /dev/mapper/crypt_dev_$dev /mnt/iroot btrfs noatime,subvolid=0,noauto 0 0
259 EOF
260 fi
261 tu /etc/crypttab <<EOF
262 crypt_dev_$dev /dev/disk/by-id/$dev /q/root/luks/host-treetowl discard,luks
263 EOF
264 if [[ ! -e /dev/mapper/crypt_dev_$dev ]]; then
265 cryptdisks_start crypt_dev_$dev
266 fi
267 done
268 # note, could do an else here and have some kind of mount for /i
269 # on other hosts.
270 fi
271
272 exit $ret